/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Russell Boykin       - initial API and implementation
 *     Alberto Giammaria    - initial API and implementation
 *     Chris Peters         - initial API and implementation
 *     Gianluca Bernardini  - initial API and implementation
 *	   Sam Padgett          - initial API and implementation
 *     Michael Fiedler      - adapted for OSLC4J
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *     Matthieu Helleboid   - Support for multiple Service Providers.
 *     Anass Radouani       - Support for multiple Service Providers.
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/

package se.kth.md.assume.adaptors.pror.resources;

import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.Iterator;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.ws.rs.core.UriBuilder;

import org.eclipse.lyo.oslc4j.core.annotation.OslcAllowedValue;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDescription;
import org.eclipse.lyo.oslc4j.core.annotation.OslcMemberProperty;
import org.eclipse.lyo.oslc4j.core.annotation.OslcName;
import org.eclipse.lyo.oslc4j.core.annotation.OslcNamespace;
import org.eclipse.lyo.oslc4j.core.annotation.OslcOccurs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcPropertyDefinition;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRange;
import org.eclipse.lyo.oslc4j.core.annotation.OslcReadOnly;
import org.eclipse.lyo.oslc4j.core.annotation.OslcRepresentation;
import org.eclipse.lyo.oslc4j.core.annotation.OslcResourceShape;
import org.eclipse.lyo.oslc4j.core.annotation.OslcTitle;
import org.eclipse.lyo.oslc4j.core.annotation.OslcValueType;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.Occurs;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.Representation;
import org.eclipse.lyo.oslc4j.core.model.ValueType;

import se.kth.md.assume.adaptors.pror.servlet.ServletListener;
import se.kth.md.assume.adaptors.pror.ProRConstants;

// Start of user code imports
// End of user code

// Start of user code preClassCode
// End of user code

// Start of user code classAnnotations
// End of user code
@OslcNamespace(ProRConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE)
@OslcName(ProRConstants.REQUIREMENTCOLLECTION)
@OslcResourceShape(title = "RequirementCollection Resource Shape", describes = ProRConstants.TYPE_REQUIREMENTCOLLECTION)
public class RequirementCollection
    extends AbstractResource
    implements IRequirementCollection
{
    // Start of user code attributeAnnotation:uses
// End of user code
    private HashSet<Link> uses = new HashSet<Link>();
    // Start of user code attributeAnnotation:title
// End of user code
    private String title;
    // Start of user code attributeAnnotation:description
// End of user code
    private String description;
    // Start of user code attributeAnnotation:identifier
// End of user code
    private String identifier;
    // Start of user code attributeAnnotation:elaborates
// End of user code
    private HashSet<Link> elaborates = new HashSet<Link>();
    // Start of user code attributeAnnotation:elaborated_by
// End of user code
    private HashSet<Link> elaborated_by = new HashSet<Link>();
    // Start of user code attributeAnnotation:documentation
    // End of user code
    private HashSet<Link> documentation = new HashSet<Link>();
    
    // Start of user code classAttributes
// End of user code
    // Start of user code classMethods
// End of user code
    public RequirementCollection()
           throws URISyntaxException
    {
        super();
    
        // Start of user code constructor1
        // End of user code
    }
    
    public RequirementCollection(final URI about)
           throws URISyntaxException
    {
        super(about);
    
        // Start of user code constructor2
        // End of user code
    }
    
    public RequirementCollection(final String serviceProviderId, final String requirementCollectionId)
           throws URISyntaxException
    {
        this (constructURI(serviceProviderId, requirementCollectionId));
        // Start of user code constructor3
        // End of user code
    }
    
    public static URI constructURI(final String serviceProviderId, final String requirementCollectionId)
    {
        String basePath = ServletListener.getServicesBase();
        Map<String, Object> pathParameters = new HashMap<String, Object>();
        pathParameters.put("serviceProviderId", serviceProviderId);
        pathParameters.put("requirementCollectionId", requirementCollectionId);
        String instanceURI = "rm-services/{serviceProviderId}/resources/requirementCollections/{requirementCollectionId}";
    
        final UriBuilder builder = UriBuilder.fromUri(basePath);
        return builder.path(instanceURI).buildFromMap(pathParameters);
    }
    
    public static Link constructLink(final String serviceProviderId, final String requirementCollectionId , final String label)
    {
        return new Link(constructURI(serviceProviderId, requirementCollectionId), label);
    }
    
    public static Link constructLink(final String serviceProviderId, final String requirementCollectionId)
    {
        return new Link(constructURI(serviceProviderId, requirementCollectionId));
    }
    
    public String toString()
    {
        return toString(false);
    }
    
    public String toString(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toString_init
        // End of user code
    
        if (asLocalResource) {
            result = result + "{a Local RequirementCollection Resource} - update RequirementCollection.toString() to present resource as desired.";
            // Start of user code toString_bodyForLocalResource
            // End of user code
        }
        else {
            result = getAbout().toString();
        }
    
        // Start of user code toString_finalize
        // End of user code
    
        return result;
    }
    
    public String toHtml()
    {
        return toHtml(false);
    }
    
    public String toHtml(boolean asLocalResource)
    {
        String result = "";
        // Start of user code toHtml_init
        // End of user code
    
        if (asLocalResource) {
            result = toString(true);
            // Start of user code toHtml_bodyForLocalResource
            // End of user code
        }
        else {
            result = "<a href=\"" + getAbout() + "\">" + toString() + "</a>";
        }
    
        // Start of user code toHtml_finalize
        // End of user code
    
        return result;
    }
    
    public void addUses(final Link uses)
    {
        this.uses.add(uses);
    }
    
    public void addElaborates(final Link elaborates)
    {
        this.elaborates.add(elaborates);
    }
    
    public void addElaborated_by(final Link elaborated_by)
    {
        this.elaborated_by.add(elaborated_by);
    }
    
    public void addDocumentation(final Link documentation)
    {
        this.documentation.add(documentation);
    }
    
    
    // Start of user code getterAnnotation:uses
    // End of user code
    @OslcName("uses")
    @OslcPropertyDefinition(ProRConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE + "uses")
    @OslcOccurs(Occurs.ZeroOrMany)
    @OslcValueType(ValueType.Resource)
    @OslcReadOnly(false)
    public HashSet<Link> getUses()
    {
        // Start of user code getterInit:uses
        // End of user code
        return uses;
    }
    
    // Start of user code getterAnnotation:title
    // End of user code
    @OslcName("title")
    @OslcPropertyDefinition(ProRConstants.DUBLIN_CORE_NAMSPACE + "title")
    @OslcOccurs(Occurs.ExactlyOne)
    @OslcValueType(ValueType.XMLLiteral)
    @OslcReadOnly(false)
    public String getTitle()
    {
        // Start of user code getterInit:title
        // End of user code
        return title;
    }
    
    // Start of user code getterAnnotation:description
    // End of user code
    @OslcName("description")
    @OslcPropertyDefinition(ProRConstants.DUBLIN_CORE_NAMSPACE + "description")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.XMLLiteral)
    @OslcReadOnly(false)
    public String getDescription()
    {
        // Start of user code getterInit:description
        // End of user code
        return description;
    }
    
    // Start of user code getterAnnotation:identifier
    // End of user code
    @OslcName("identifier")
    @OslcPropertyDefinition(ProRConstants.DUBLIN_CORE_NAMSPACE + "identifier")
    @OslcOccurs(Occurs.ZeroOrOne)
    @OslcValueType(ValueType.String)
    @OslcReadOnly(false)
    public String getIdentifier()
    {
        // Start of user code getterInit:identifier
        // End of user code
        return identifier;
    }
    
    // Start of user code getterAnnotation:elaborates
    // End of user code
    @OslcName("elaborates")
    @OslcPropertyDefinition(ProRConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE + "elaborates")
    @OslcOccurs(Occurs.ZeroOrMany)
    @OslcValueType(ValueType.Resource)
    @OslcReadOnly(false)
    public HashSet<Link> getElaborates()
    {
        // Start of user code getterInit:elaborates
        // End of user code
        return elaborates;
    }
    
    // Start of user code getterAnnotation:elaborated_by
    // End of user code
    @OslcName("elaborated_by")
    @OslcPropertyDefinition(ProRConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE + "elaborated_by")
    @OslcOccurs(Occurs.ZeroOrMany)
    @OslcValueType(ValueType.Resource)
    @OslcReadOnly(false)
    public HashSet<Link> getElaborated_by()
    {
        // Start of user code getterInit:elaborated_by
        // End of user code
        return elaborated_by;
    }
    
    // Start of user code getterAnnotation:documentation
    // End of user code
    @OslcName("documentation")
    @OslcPropertyDefinition(ProRConstants.REQUIREMENTS_MANAGEMENT_NAMSPACE + "documentation")
    @OslcOccurs(Occurs.ZeroOrMany)
    @OslcValueType(ValueType.Resource)
    @OslcRepresentation(Representation.Reference)
    @OslcReadOnly(false)
    public HashSet<Link> getDocumentation()
    {
        // Start of user code getterInit:documentation
        // End of user code
        return documentation;
    }
    
    
    // Start of user code setterAnnotation:uses
    // End of user code
    public void setUses(final HashSet<Link> uses )
    {
        // Start of user code setterInit:uses
        // End of user code
        this.uses.clear();
        if (uses != null)
        {
            this.uses.addAll(uses);
        }
    
        // Start of user code setterFinalize:uses
        // End of user code
    }
    
    // Start of user code setterAnnotation:title
    // End of user code
    public void setTitle(final String title )
    {
        // Start of user code setterInit:title
        // End of user code
        this.title = title;
    
        // Start of user code setterFinalize:title
        // End of user code
    }
    
    // Start of user code setterAnnotation:description
    // End of user code
    public void setDescription(final String description )
    {
        // Start of user code setterInit:description
        // End of user code
        this.description = description;
    
        // Start of user code setterFinalize:description
        // End of user code
    }
    
    // Start of user code setterAnnotation:identifier
    // End of user code
    public void setIdentifier(final String identifier )
    {
        // Start of user code setterInit:identifier
        // End of user code
        this.identifier = identifier;
    
        // Start of user code setterFinalize:identifier
        // End of user code
    }
    
    // Start of user code setterAnnotation:elaborates
    // End of user code
    public void setElaborates(final HashSet<Link> elaborates )
    {
        // Start of user code setterInit:elaborates
        // End of user code
        this.elaborates.clear();
        if (elaborates != null)
        {
            this.elaborates.addAll(elaborates);
        }
    
        // Start of user code setterFinalize:elaborates
        // End of user code
    }
    
    // Start of user code setterAnnotation:elaborated_by
    // End of user code
    public void setElaborated_by(final HashSet<Link> elaborated_by )
    {
        // Start of user code setterInit:elaborated_by
        // End of user code
        this.elaborated_by.clear();
        if (elaborated_by != null)
        {
            this.elaborated_by.addAll(elaborated_by);
        }
    
        // Start of user code setterFinalize:elaborated_by
        // End of user code
    }
    
    // Start of user code setterAnnotation:documentation
    // End of user code
    public void setDocumentation(final HashSet<Link> documentation )
    {
        // Start of user code setterInit:documentation
        // End of user code
        this.documentation.clear();
        if (documentation != null)
        {
            this.documentation.addAll(documentation);
        }
    
        // Start of user code setterFinalize:documentation
        // End of user code
    }
    
    
    static public String usesToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:usesToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"uses\">uses: </LABEL>";
    
        // Start of user code "Mid:usesToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:usesToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String titleToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:titleToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"title\">title: </LABEL>";
    
        // Start of user code "Mid:titleToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"title\" type=\"text\" style=\"width: 400px\" id=\"title\" >";
        // Start of user code "Finalize:titleToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String descriptionToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:descriptionToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"description\">description: </LABEL>";
    
        // Start of user code "Mid:descriptionToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"description\" type=\"text\" style=\"width: 400px\" id=\"description\" >";
        // Start of user code "Finalize:descriptionToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String identifierToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:identifierToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"identifier\">identifier: </LABEL>";
    
        // Start of user code "Mid:identifierToHtmlForCreation(...)"
        // End of user code
    
        s= s + "<input name=\"identifier\" type=\"text\" style=\"width: 400px\" id=\"identifier\" >";
        // Start of user code "Finalize:identifierToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String elaboratesToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:elaboratesToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"elaborates\">elaborates: </LABEL>";
    
        // Start of user code "Mid:elaboratesToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:elaboratesToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String elaborated_byToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:elaborated_byToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"elaborated_by\">elaborated_by: </LABEL>";
    
        // Start of user code "Mid:elaborated_byToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:elaborated_byToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    static public String documentationToHtmlForCreation (final HttpServletRequest httpServletRequest)
    {
        String s = "";
    
        // Start of user code "Init:documentationToHtmlForCreation(...)"
        // End of user code
    
        s = s + "<label for=\"documentation\">documentation: </LABEL>";
    
        // Start of user code "Mid:documentationToHtmlForCreation(...)"
        // End of user code
    
        // Start of user code "Finalize:documentationToHtmlForCreation(...)"
        // End of user code
    
        return s;
    }
    
    
    public String usesToHtml()
    {
        String s = "";
    
        // Start of user code usestoHtml_init
        // End of user code
    
        s = s + "<label for=\"uses\"><strong>uses</strong>: </LABEL>";
    
        // Start of user code usestoHtml_mid
        // End of user code
    
        try {
            s = s + "<ul>";
            for(Link next : uses) {
                s = s + "<li>";
                if (next.getValue() == null) {
                    s= s + "<em>null</em>";
                }
                else {
                    s = s + next.getValue().toString();
                }
                s = s + "</li>";
            }
            s = s + "</ul>";
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code usestoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String titleToHtml()
    {
        String s = "";
    
        // Start of user code titletoHtml_init
        // End of user code
    
        s = s + "<label for=\"title\"><strong>title</strong>: </LABEL>";
    
        // Start of user code titletoHtml_mid
        // End of user code
    
        try {
            if (title == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + title.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code titletoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String descriptionToHtml()
    {
        String s = "";
    
        // Start of user code descriptiontoHtml_init
        // End of user code
    
        s = s + "<label for=\"description\"><strong>description</strong>: </LABEL>";
    
        // Start of user code descriptiontoHtml_mid
        // End of user code
    
        try {
            if (description == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + description.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code descriptiontoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String identifierToHtml()
    {
        String s = "";
    
        // Start of user code identifiertoHtml_init
        // End of user code
    
        s = s + "<label for=\"identifier\"><strong>identifier</strong>: </LABEL>";
    
        // Start of user code identifiertoHtml_mid
        // End of user code
    
        try {
            if (identifier == null) {
                s= s + "<em>null</em>";
            }
            else {
                s= s + identifier.toString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code identifiertoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String elaboratesToHtml()
    {
        String s = "";
    
        // Start of user code elaboratestoHtml_init
        // End of user code
    
        s = s + "<label for=\"elaborates\"><strong>elaborates</strong>: </LABEL>";
    
        // Start of user code elaboratestoHtml_mid
        // End of user code
    
        try {
            s = s + "<ul>";
            for(Link next : elaborates) {
                s = s + "<li>";
                if (next.getValue() == null) {
                    s= s + "<em>null</em>";
                }
                else {
                    s = s + next.getValue().toString();
                }
                s = s + "</li>";
            }
            s = s + "</ul>";
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code elaboratestoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String elaborated_byToHtml()
    {
        String s = "";
    
        // Start of user code elaborated_bytoHtml_init
        // End of user code
    
        s = s + "<label for=\"elaborated_by\"><strong>elaborated_by</strong>: </LABEL>";
    
        // Start of user code elaborated_bytoHtml_mid
        // End of user code
    
        try {
            s = s + "<ul>";
            for(Link next : elaborated_by) {
                s = s + "<li>";
                if (next.getValue() == null) {
                    s= s + "<em>null</em>";
                }
                else {
                    s = s + next.getValue().toString();
                }
                s = s + "</li>";
            }
            s = s + "</ul>";
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code elaborated_bytoHtml_finalize
        // End of user code
    
        return s;
    }
    
    public String documentationToHtml()
    {
        String s = "";
    
        // Start of user code documentationtoHtml_init
        // End of user code
    
        s = s + "<label for=\"documentation\"><strong>documentation</strong>: </LABEL>";
    
        // Start of user code documentationtoHtml_mid
        // End of user code
    
        try {
            s = s + "<ul>";
            for(Link next : documentation) {
                s = s + "<li>";
                if (next.getValue() == null) {
                    s= s + "<em>null</em>";
                }
                else {
                    s = s + next.getValue().toString();
                }
                s = s + "</li>";
            }
            s = s + "</ul>";
        } catch (Exception e) {
            e.printStackTrace();
        }
    
        // Start of user code documentationtoHtml_finalize
        // End of user code
    
        return s;
    }
    
    
}
